//-----------------------------------------------------------------------------
//  (c) 2007-2011 by Basler Vision Technologies
//  Division: Machine Vision
//  Sample for optimizing GigE packetsize and interpacket delay
//  Author:  M.Binev
//  Header: OptimizeGigESettings.h
// 
//	returns:	- 0 if no error occured and function suceeded
//				- 1 if function got a grab timeout when calculating 
//					the interpacket delay
//				- GrabResult::GetErrorCode() if function got a grab 
//				    error when calculating the interpacket delay
//-----------------------------------------------------------------------------

#ifndef __OPTIMIZEGIGESETTINGS_H__
#define __OPTIMIZEGIGESETTINGS_H__

#if _MSC_VER > 1000
#pragma once
#endif //_MSC_VER > 1000

// include files to use the PYLON API
#include <pylon/PylonIncludes.h>
#include <pylon/PylonBootstrapper.h>
#include <pylon/TlFactory.h>
#include <pylon/Result.h>
using namespace Pylon;

// settings to use Basler GigE cameras
#include <pylon/gige/BaslerGigeCamera.h>
using namespace Basler_GigECameraParams;
using namespace Basler_GigEStreamParams;
using namespace Basler_GigETLParams;
using namespace std;
using namespace GenApi;
using namespace GenICam;

#include <shellapi.h>
#include <iostream>
#include <fstream>
#include <assert.h>
#include <atlstr.h>
#include <string>

const char outfile[]= "optimizeGigE.txt";	
uint32_t OptimizeGigESettings (Pylon::CBaslerGigECamera &Camera, int64_t iInitialPacketSize, std::ostream& file);
int64_t OptimizeBandwidth (Pylon::String_t& SN, int bandwidth, std::ostream& file);

#endif //__OPTIMIZEGIGESETTINGS_H__