//-----------------------------------------------------------------------------
//  (c) 2011 by Basler Vision Technologies
//  Division: Machine Vision
//  Sample for storing a configuration set and make it the startup set
//  Author:  M.Binev
//  Implementation: StoreConfigurationSet.cpp
//-----------------------------------------------------------------------------

#include <StoreConfigurationSet.h>

void StoreToConfigSet (Pylon::CBaslerGigECamera &Camera, 
					   int64_t PacketSize,
					   int64_t InterPacketDelay,
					   UserSetSelectorEnums UserSet, 
					   bool bStartUp)
{
    try
    {
		Camera.Open ();
		
		// Select choosen User Set 
		Camera.UserSetSelector.SetValue (UserSet);

		// Write and save settings
		Camera.GevSCPSPacketSize.SetValue (PacketSize);
		Camera.GevSCPD.SetValue (InterPacketDelay);
		Camera.UserSetSave.Execute ();

		// Make the User Set become the Startup set
		if (bStartUp)
		{
			UserSetDefaultSelectorEnums StartupSet;
			switch (UserSet)
			{
			case UserSetSelector_UserSet1:
					StartupSet = UserSetDefaultSelector_UserSet1;
				break;
			case UserSetSelector_UserSet2:
					StartupSet = UserSetDefaultSelector_UserSet2;
				break;
			case UserSetSelector_UserSet3:
					StartupSet = UserSetDefaultSelector_UserSet3;
				break;
			}			
			Camera.UserSetDefaultSelector.SetValue (StartupSet);
		}
		
		Camera.Close ();
	}
    catch (GenICam::GenericException &e)
    {
        throw e;
    }
}
